<?php

namespace Alike\Admin;

/**
*
*/
class Ra_Admin_cpt {

  public function __construct() {
    add_action( 'init', [$this, 'wpdocs_codex_comparison_init'] );
   // add_filter('single_template', [$this, 'my_custom_template']);

  }

  public function wpdocs_codex_comparison_init() {
    $labels = array(
      'name'                  => _x( 'Comparisons', 'Post type general name', 'alike' ),
      'singular_name'         => _x( 'Comparison', 'Post type singular name', 'alike' ),
      'menu_name'             => _x( 'Comparisons', 'Admin Menu text', 'alike' ),
      'name_admin_bar'        => _x( 'Comparison', 'Add New on Toolbar', 'alike' ),
      'add_new'               => __( 'Add New', 'alike' ),
      'add_new_item'          => __( 'Add New Comparison', 'alike' ),
      'new_item'              => __( 'New Comparison', 'alike' ),
      'edit_item'             => __( 'Edit Comparison', 'alike' ),
      'view_item'             => __( 'View Comparison', 'alike' ),
      'all_items'             => __( 'All Comparisons', 'alike' ),
      'search_items'          => __( 'Search Comparisons', 'alike' ),
      'parent_item_colon'     => __( 'Parent Comparisons:', 'alike' ),
      'not_found'             => __( 'No Comparisons found.', 'alike' ),
      'not_found_in_trash'    => __( 'No Comparisons found in Trash.', 'alike' ),
      'featured_image'        => _x( 'Comparison Cover Image', 'Overrides the “Featured Image” phrase for this post type. Added in 4.3', 'alike' ),
      'set_featured_image'    => _x( 'Set cover image', 'Overrides the “Set featured image” phrase for this post type. Added in 4.3', 'alike' ),
      'remove_featured_image' => _x( 'Remove cover image', 'Overrides the “Remove featured image” phrase for this post type. Added in 4.3', 'alike' ),
      'use_featured_image'    => _x( 'Use as cover image', 'Overrides the “Use as featured image” phrase for this post type. Added in 4.3', 'alike' ),
      'archives'              => _x( 'Comparison archives', 'The post type archive label used in nav menus. Default “Post Archives”. Added in 4.4', 'alike' ),
      'insert_into_item'      => _x( 'Insert into Comparison', 'Overrides the “Insert into post”/”Insert into page” phrase (used when inserting media into a post). Added in 4.4', 'alike' ),
      'uploaded_to_this_item' => _x( 'Uploaded to this Comparison', 'Overrides the “Uploaded to this post”/”Uploaded to this page” phrase (used when viewing media attached to a post). Added in 4.4', 'alike' ),
      'filter_items_list'     => _x( 'Filter Comparisons list', 'Screen reader text for the filter links heading on the post type listing screen. Default “Filter posts list”/”Filter pages list”. Added in 4.4', 'alike' ),
      'items_list_navigation' => _x( 'Comparisons list navigation', 'Screen reader text for the pagination heading on the post type listing screen. Default “Posts list navigation”/”Pages list navigation”. Added in 4.4', 'alike' ),
      'items_list'            => _x( 'Comparisons list', 'Screen reader text for the items list heading on the post type listing screen. Default “Posts list”/”Pages list”. Added in 4.4', 'alike' ),
    );
  
    $args = array(
      'labels'             => $labels,
      'public'             => true,
      'publicly_queryable' => true,
      'show_ui'            => true,
      'show_in_menu'       => false,
      'query_var'          => true,
      'rewrite'            => array( 'slug' => 'Comparison' ),
      'capability_type'    => 'post',
      'has_archive'        => true,
      'hierarchical'       => false,
      'menu_position'      => null,
      'show_in_rest'       => true,
      'supports'           => array( 'title', 'editor', 'custom-fields'),
    );
  
    register_post_type( 'comparison', $args );
  }
  public function my_custom_template($single) {
    global $post;

    /* Checks for single template by post type */
    if ( $post->post_type == 'comparison' ) {
       
            return __DIR__.'../admin-templates/comparison.php';
        
    }

    return $single;
  }

} // end of class